/* Parcurgeri in vectori
 */ 
#include <iostream>
#include <vector>
using namespace std;
// size() -> O(1)

int main()
{
	vector<int> v; // declar un vector vid
	
	v.push_back(10);
	v.push_back(20);
	v.push_back(30);
	v.push_back(40);
	
	// 1
	// size_t - tip intreg fara semn
	for (size_t i = 0; i < v.size(); ++i)
		cout << v[i] << ' ';
	cout << '\n';
	
	// 2
	for (vector<int>::iterator it = v.begin(); it != v.end(); ++it)
		cout << *it << ' ';
	cout << '\n';
	// *it = valoare indicata de catre iterator
	// * - Operator de dereferentiere
	
	// 3
	for (auto it = v.begin(); it != v.end(); ++it)
		cout << *it << ' ';
	cout << '\n';
	
	// 4
	// "Range Based for Loop - Ciclul for bazat pe intervale
	for (int x : v)
		cout << x << ' ';
	
	return 0;
}
